<?php

class DispletRetsIdxEmails{
	public function get_admin_email_address(){
		$displetretsidx_option = DispletRetsIdxSettings::get_option();
		$admin_email = (!empty($displetretsidx_option['email'])) ? $displetretsidx_option['email'] : get_option('admin_email');
		if (strpos($admin_email, ',') !== false) {
			$admin_emails = explode(',', $admin_email);
			$admin_email = array();
			foreach ($admin_emails as $email) {
				$admin_email[] = trim($email);
			}
		}
		return $admin_email;
	}

	public function set_admin_email_as_sender($email_address){
		$displetretsidx_option = DispletRetsIdxSettings::get_option();
		if (!empty($displetretsidx_option['email_from_address'])) {
			$email_address = $displetretsidx_option['email_from_address'];
		}
		return $email_address;
	}

	public function set_admin_name_as_sender($email_name){
		$displetretsidx_option = DispletRetsIdxSettings::get_option();
		if (!empty($displetretsidx_option['email_from_name'])) {
			$email_name = $displetretsidx_option['email_from_name'];
		}
		return $email_name;
	}

	public function send_new_user_registration($email, $name, $phone, $url, $username, $random_password){
		$displetretsidx_option = DispletRetsIdxSettings::get_option();
		$admin_email = self::get_admin_email_address();
		$site_name = get_bloginfo('name');
		$site_url = site_url();

		// Set admin as email sender
		add_filter('wp_mail_from', array('DispletRetsIdxEmails', 'set_admin_email_as_sender'));
		add_filter('wp_mail_from_name',array('DispletRetsIdxEmails', 'set_admin_name_as_sender'));

		// Message to admin
		if (!empty($displetretsidx_option['email_template_new_registration_to_admin'])) {
			$admin_message = str_replace('%%user_name%%', $name, stripslashes($displetretsidx_option['email_template_new_registration_to_admin']));
			$admin_message = str_replace('%%user_email%%', $email, $admin_message);
			$admin_message = str_replace('%%user_phone%%', $phone, $admin_message);
			$admin_message = str_replace('%%registration_url%%', $url, $admin_message);
			$admin_message = str_replace('%%user_username%%', $username, $admin_message);
			$admin_message = str_replace('%%site_name%%', $site_name, $admin_message);
			$admin_message = str_replace('%%site_url%%', $site_url, $admin_message);
		}
		else {
			$admin_message =
				'User Name: ' . $name . "\r\n" .
				'User Email: ' . $email . "\r\n" .
				'User Phone: ' . $phone . "\r\n" .
				'Registration Page: ' . $url;
		}
		if (!empty($displetretsidx_option['email_signature'])) {
			$email_signature = str_replace('%%site_name%%', $site_name, stripslashes($displetretsidx_option['email_signature']));
			$email_signature = str_replace('%%site_url%%', $site_url, $email_signature);
			$admin_message .= "\r\n\r\n" . $email_signature;
		}
		if (!empty($displetretsidx_option['email_title_new_registration_to_admin'])) {
			$admin_title = str_replace('%%user_name%%', $name, stripslashes($displetretsidx_option['email_title_new_registration_to_admin']));
			$admin_title = str_replace('%%user_email%%', $email, $admin_title);
			$admin_title = str_replace('%%user_phone%%', $phone, $admin_title);
			$admin_title = str_replace('%%registration_url%%', $url, $admin_title);
			$admin_title = str_replace('%%user_username%%', $username, $admin_title);
			$admin_title = str_replace('%%site_name%%', $site_name, $admin_title);
			$admin_title = str_replace('%%site_url%%', $site_url, $admin_title);
		}
		else{
			$admin_title = 'A New User Has Registered at ' . $site_url;
		}
		wp_mail($admin_email, $admin_title, $admin_message);

		// Message to user
		if (!empty($displetretsidx_option['email_template_new_registration_to_user'])) {
			$user_message = str_replace('%%user_name%%', $name, stripslashes($displetretsidx_option['email_template_new_registration_to_user']));
			$user_message = str_replace('%%user_email%%', $email, $user_message);
			$user_message = str_replace('%%user_phone%%', $phone, $user_message);
			$user_message = str_replace('%%user_username%%', $username, $user_message);
			$user_message = str_replace('%%user_password%%', $random_password, $user_message);
			$user_message = str_replace('%%site_name%%', $site_name, $user_message);
			$user_message = str_replace('%%site_url%%', $site_url, $user_message);
			$user_message = str_replace('%%registration_url%%', $url, $user_message);
		}
		else{
			$user_message =
				'Thank you for registering at ' . site_url() . '.' . "\r\n" .
				'Name: ' . $name . "\r\n" .
				'Email: ' . $email . "\r\n" .
				'Phone: ' . $phone . "\r\n" .
				'Password: ' . $random_password;
		}
		if (!empty($displetretsidx_option['email_signature'])) {
			$email_signature = str_replace('%%site_name%%', $site_name, stripslashes($displetretsidx_option['email_signature']));
			$email_signature = str_replace('%%site_url%%', $site_url, $email_signature);
			$user_message .= "\r\n\r\n" . $email_signature;
		}
		if (!empty($displetretsidx_option['email_title_new_registration_to_user'])) {
			$user_title = str_replace('%%user_name%%', $name, stripslashes($displetretsidx_option['email_title_new_registration_to_user']));
			$user_title = str_replace('%%user_email%%', $email, $user_title);
			$user_title = str_replace('%%user_phone%%', $phone, $user_title);
			$user_title = str_replace('%%registration_url%%', $url, $user_title);
			$user_title = str_replace('%%user_username%%', $username, $user_title);
			$user_title = str_replace('%%site_name%%', $site_name, $user_title);
			$user_title = str_replace('%%site_url%%', $site_url, $user_title);
		}
		else{
			$user_title = 'New Account Details for ' . $site_url;
		}
		wp_mail($email, $user_title, $user_message);
		
		// Remove admin as email sender
		remove_filter('wp_mail_from', array('DispletRetsIdxEmails', 'set_admin_email_as_sender'));
		remove_filter('wp_mail_from_name',array('DispletRetsIdxEmails', 'set_admin_name_as_sender'));
	}

	public function send_property_showing_request(){
		// Check nonce for security
		check_ajax_referer('displet_property_showing_nonce');

		if (isset($_POST['action']) && $_POST['action'] == 'displet_property_showing_request'){
			if (!empty($_POST['name']) && !empty($_POST['email']) && !empty($_POST['phone'])) {
				if (is_email($_POST['email'])) {
					$displetretsidx_option = DispletRetsIdxSettings::get_option();
					$admin_email = self::get_admin_email_address();
					$site_name = get_bloginfo('name');
					$site_url = site_url();
					$address = trim($_POST['address']) . ', ' . trim($_POST['city']) . ', ' . trim($_POST['state']) . ' ' . trim($_POST['zip']);

					// Set admin as email sender
					add_filter('wp_mail_from', array('DispletRetsIdxEmails', 'set_admin_email_as_sender'));
					add_filter('wp_mail_from_name',array('DispletRetsIdxEmails', 'set_admin_name_as_sender'));

					// Send message to admin
					if (!empty($displetretsidx_option['email_template_property_showing_to_admin'])) {
						$admin_message = str_replace('%%user_name%%', $_POST['name'], stripslashes($displetretsidx_option['email_template_property_showing_to_admin']));
						$admin_message = str_replace('%%user_email%%', $_POST['email'], $admin_message);
						$admin_message = str_replace('%%user_phone%%', $_POST['phone'], $admin_message);
						$admin_message = str_replace('%%user_appointment%%', $_POST['appointment1'], $admin_message);
						$admin_message = str_replace('%%user_appointment2%%', $_POST['appointment2'], $admin_message);
						$admin_message = str_replace('%%user_message%%', trim($_POST['message']), $admin_message);
						$admin_message = str_replace('%%property_address%%', $address, $admin_message);
						$admin_message = str_replace('%%property_url%%', $_POST['url'], $admin_message);
						$admin_message = str_replace('%%site_name%%', $site_name, $admin_message);
						$admin_message = str_replace('%%site_url%%', $site_url, $admin_message);
					}
					else {
						$admin_message = 
							$_POST['url'] . "\r\n" .
							'Property: ' . $address . "\r\n" .
							'Name: ' . $_POST['name'] . "\r\n" .
							'Email: ' . $_POST['email'] . "\r\n" .
							'Phone: ' . $_POST['phone'] . "\r\n" .
							'Appointment 1: ' . $_POST['appointment1'] . "\r\n" .
							'Appointment 2: ' . $_POST['appointment2'] . "\r\n" .
							'Message: ' . $_POST['message'];
					}
					if (!empty($displetretsidx_option['email_signature'])) {
						$email_signature = str_replace('%%site_name%%', $site_name, stripslashes($displetretsidx_option['email_signature']));
						$email_signature = str_replace('%%site_url%%', $site_url, $email_signature);
						$admin_message .= "\r\n\r\n" . $email_signature;
					}
					if (!empty($displetretsidx_option['email_title_property_showing_to_admin'])) {
						$admin_title = str_replace('%%user_name%%', $_POST['name'], stripslashes($displetretsidx_option['email_title_property_showing_to_admin']));
						$admin_title = str_replace('%%user_email%%', $_POST['email'], $admin_title);
						$admin_title = str_replace('%%user_phone%%', $_POST['phone'], $admin_title);
						$admin_title = str_replace('%%user_appointment%%', $_POST['appointment1'], $admin_title);
						$admin_title = str_replace('%%user_appointment2%%', $_POST['appointment2'], $admin_title);
						$admin_title = str_replace('%%user_message%%', trim($_POST['message']), $admin_title);
						$admin_title = str_replace('%%property_address%%', $address, $admin_title);
						$admin_title = str_replace('%%property_url%%', $_POST['url'], $admin_title);
						$admin_title = str_replace('%%site_name%%', $site_name, $admin_title);
						$admin_title = str_replace('%%site_url%%', $site_url, $admin_title);
					}
					else {
						$admin_title = 'Property Showing Request';
					}
					wp_mail($admin_email, $admin_title, $admin_message);

					// Send message to user
					if (!empty($displetretsidx_option['email_template_property_showing_to_user'])) {
						$user_message = str_replace('%%user_name%%', $_POST['name'], stripslashes($displetretsidx_option['email_template_property_showing_to_user']));
						$user_message = str_replace('%%user_email%%', $_POST['email'], $user_message);
						$user_message = str_replace('%%user_phone%%', $_POST['phone'], $user_message);
						$user_message = str_replace('%%user_appointment%%', $_POST['appointment1'], $user_message);
						$user_message = str_replace('%%user_appointment2%%', $_POST['appointment2'], $user_message);
						$user_message = str_replace('%%user_message%%', trim($_POST['message']), $user_message);
						$user_message = str_replace('%%property_address%%', $address, $user_message);
						$user_message = str_replace('%%property_url%%', $_POST['url'], $user_message);
						$user_message = str_replace('%%site_name%%', $site_name, $user_message);
						$user_message = str_replace('%%site_url%%', $site_url, $user_message);
					}
					else {
						$user_message = 
							$_POST['url'] . "\r\n" .
							'Property: ' . $address . "\r\n" .
							'Name: ' . $_POST['name'] . "\r\n" .
							'Email: ' . $_POST['email'] . "\r\n" .
							'Phone: ' . $_POST['phone'] . "\r\n" .
							'Appointment 1: ' . $_POST['appointment1'] . "\r\n" .
							'Appointment 2: ' . $_POST['appointment2'] . "\r\n" .
							'Message: ' . $_POST['message'];
					}
					if (!empty($displetretsidx_option['email_signature'])) {
						$email_signature = str_replace('%%site_name%%', $site_name, stripslashes($displetretsidx_option['email_signature']));
						$email_signature = str_replace('%%site_url%%', $site_url, $email_signature);
						$user_message .= "\r\n\r\n" . $email_signature;
					}
					if (!empty($displetretsidx_option['email_title_property_showing_to_user'])) {
						$user_title = str_replace('%%user_name%%', $_POST['name'], stripslashes($displetretsidx_option['email_title_property_showing_to_user']));
						$user_title = str_replace('%%user_email%%', $_POST['email'], $user_title);
						$user_title = str_replace('%%user_phone%%', $_POST['phone'], $user_title);
						$user_title = str_replace('%%user_appointment%%', $_POST['appointment1'], $user_title);
						$user_title = str_replace('%%user_appointment2%%', $_POST['appointment2'], $user_title);
						$user_title = str_replace('%%user_message%%', trim($_POST['message']), $user_title);
						$user_title = str_replace('%%property_address%%', $address, $user_title);
						$user_title = str_replace('%%property_url%%', $_POST['url'], $user_title);
						$user_title = str_replace('%%site_name%%', $site_name, $user_title);
						$user_title = str_replace('%%site_url%%', $site_url, $user_title);
					}
					else {
						$user_title = 'Property Showing Request Received';
					}
					wp_mail($_POST['email'], $user_title, $user_message);

					// Remove admin as email sender
					remove_filter('wp_mail_from', array('DispletRetsIdxEmails', 'set_admin_email_as_sender'));
					remove_filter('wp_mail_from_name',array('DispletRetsIdxEmails', 'set_admin_name_as_sender'));

					// Send to Zapier
					$zap_user = array(
						'email' => $_POST['email'],
						'name' => $_POST['name'],
						'phone' => $_POST['phone'],
						'address' => $address,
						'first_appointment' => $_POST['appointment1'],
						'second_appointment' => $_POST['appointment2'],
						'message' => $_POST['message']
					);
					DispletRetsIdxUsers::send_to_zapier($zap_user, 'showing');
					
					echo 'Your request has been sent.';
				}
				else{
					echo 'Please enter a valid email address.';
				}
			}
			else{
				echo 'Please complete the required fields.';
			}
			die();
		}
		
		echo 'We\'re sorry, there was an error processing your request. Please try again.';
		die();
	}

	public function send_email_to_friend_request(){
		// Check nonce for security
		check_ajax_referer('displet_email_friend_nonce');

		if (isset($_POST['action']) && $_POST['action'] == 'displet_email_friend_request'){
			if (!empty($_POST['email']) && is_email($_POST['email'])) {
				$displetretsidx_option = DispletRetsIdxSettings::get_option();
				$admin_email = self::get_admin_email_address();
				$site_name = get_bloginfo('name');
				$site_url = site_url();
				$current_user = wp_get_current_user();
				if (!empty($current_user->ID)) {
					$user = get_userdata($current_user->ID);
					if (!empty($user->nickname)) {
						$current_user->nickname = $user->nickname;
					}
				}
				$user_name = (!empty($current_user->nickname)) ? $current_user->nickname : 'A Friend';
				$user_email = (!empty($current_user->user_email)) ? $current_user->user_email : '';
				$address = trim($_POST['address']) . ', ' . trim($_POST['city']) . ', ' . trim($_POST['state']) . ' ' . trim($_POST['zip']);

				// Set admin as email sender
				add_filter('wp_mail_from', array('DispletRetsIdxEmails', 'set_admin_email_as_sender'));
				add_filter('wp_mail_from_name',array('DispletRetsIdxEmails', 'set_admin_name_as_sender'));

				// Message to admin
				if (!empty($displetretsidx_option['email_template_email_friend_to_admin'])) {
					$admin_message = str_replace('%%user_name%%', $user_name, stripslashes($displetretsidx_option['email_template_email_friend_to_admin']));
					$admin_message = str_replace('%%user_email%%', $user_email, $admin_message);
					$admin_message = str_replace('%%friend_name%%', $_POST['name'], $admin_message);
					$admin_message = str_replace('%%friend_email%%', $_POST['email'], $admin_message);
					$admin_message = str_replace('%%user_message%%', $_POST['message'], $admin_message);
					$admin_message = str_replace('%%property_address%%', $address, $admin_message);
					$admin_message = str_replace('%%property_url%%', $_POST['url'], $admin_message);
					$admin_message = str_replace('%%site_name%%', $site_name, $admin_message);
					$admin_message = str_replace('%%site_url%%', $site_url, $admin_message);
				}
				else {
					$admin_message =
						$_POST['url'] . "\r\n" .
						'Property: ' . $address . "\r\n" .
						'Friend Name: ' . $_POST['name'] . "\r\n" .
						'Friend Email: ' . $_POST['email'] . "\r\n" .
						'User Message: ' . $_POST['message'];
				}
				if (!empty($displetretsidx_option['email_signature'])) {
					$email_signature = str_replace('%%site_name%%', $site_name, stripslashes($displetretsidx_option['email_signature']));
					$email_signature = str_replace('%%site_url%%', $site_url, $email_signature);
					$admin_message .= "\r\n\r\n" . $email_signature;
				}
				if (!empty($displetretsidx_option['email_title_email_friend_to_admin'])) {
					$admin_title = str_replace('%%user_name%%', $user_name, stripslashes($displetretsidx_option['email_title_email_friend_to_admin']));
					$admin_title = str_replace('%%user_email%%', $user_email, $admin_title);
					$admin_title = str_replace('%%friend_name%%', $_POST['name'], $admin_title);
					$admin_title = str_replace('%%friend_email%%', $_POST['email'], $admin_title);
					$admin_title = str_replace('%%user_message%%', $_POST['message'], $admin_title);
					$admin_title = str_replace('%%property_address%%', $address, $admin_title);
					$admin_title = str_replace('%%property_url%%', $_POST['url'], $admin_title);
					$admin_title = str_replace('%%site_name%%', $site_name, $admin_title);
					$admin_title = str_replace('%%site_url%%', $site_url, $admin_title);
				}
				else {
					$admin_title = 'Property Emailed To A Friend from ' . $site_url;
				}
				wp_mail($admin_email, $admin_title, $admin_message);

				// Message to friend
				if (!empty($displetretsidx_option['email_template_email_friend_to_user'])) {
					$user_message = str_replace('%%user_name%%', $user_name, stripslashes($displetretsidx_option['email_template_email_friend_to_user']));
					$user_message = str_replace('%%user_email%%', $user_email, $user_message);
					$user_message = str_replace('%%friend_name%%', $_POST['name'], $user_message);
					$user_message = str_replace('%%friend_email%%', $_POST['email'], $user_message);
					$user_message = str_replace('%%user_message%%', $_POST['message'], $user_message);
					$user_message = str_replace('%%property_address%%', $address, $user_message);
					$user_message = str_replace('%%property_url%%', $_POST['url'], $user_message);
					$user_message = str_replace('%%site_name%%', $site_name, $user_message);
					$user_message = str_replace('%%site_url%%', $site_url, $user_message);
				}
				else {
					$user_message =
						$_POST['url'] . "\r\n" .
						'Property: ' . $_POST['address'] . ', ' . $_POST['city'] . ', ' . $_POST['state'] . ' ' . $_POST['zip'] . "\r\n" .
						'Message from ' . $_POST['name'] . ': ' . $_POST['message'];
				}
				if (!empty($displetretsidx_option['email_title_email_friend_to_user'])) {
					$user_title = str_replace('%%user_name%%', $user_name, stripslashes($displetretsidx_option['email_title_email_friend_to_user']));
					$user_title = str_replace('%%user_email%%', $user_email, $user_title);
					$user_title = str_replace('%%friend_name%%', $_POST['name'], $user_title);
					$user_title = str_replace('%%friend_email%%', $_POST['email'], $user_title);
					$user_title = str_replace('%%user_message%%', $_POST['message'], $user_title);
					$user_title = str_replace('%%property_address%%', $address, $user_title);
					$user_title = str_replace('%%property_url%%', $_POST['url'], $user_title);
					$user_title = str_replace('%%site_name%%', $site_name, $user_title);
					$user_title = str_replace('%%site_url%%', $site_url, $user_title);
				}
				else {
					$user_title = $user_name . ' Thinks You\'ll Like ' . $address;
				}
				wp_mail($_POST['email'], $user_title, $user_message);
					
				// Remove admin as email sender
				remove_filter('wp_mail_from', array('DispletRetsIdxEmails', 'set_admin_email_as_sender'));
				remove_filter('wp_mail_from_name',array('DispletRetsIdxEmails', 'set_admin_name_as_sender'));
				
				echo 'Your message has been sent.';
			}
			else{
				echo 'Please enter a valid email address.';
			}
			die();
		}
		
		echo 'We\'re sorry, there was an error processing your request. Please try again.';
		die();
	}
}

add_action('wp_ajax_displet_property_showing_request', array('DispletRetsIdxEmails', 'send_property_showing_request'));
add_action('wp_ajax_nopriv_displet_property_showing_request', array('DispletRetsIdxEmails', 'send_property_showing_request'));
add_action('wp_ajax_displet_email_friend_request', array('DispletRetsIdxEmails', 'send_email_to_friend_request'));
add_action('wp_ajax_nopriv_displet_email_friend_request', array('DispletRetsIdxEmails', 'send_email_to_friend_request'));

/* Sets to HTML formatting
function displetretsidx_format_emails_as_html(){
    return "text/html";
}
add_filter('wp_mail_content_type','displetretsidx_format_emails_as_html');
// Send Email between adding and removing
remove_filter('wp_mail_content_type','displetretsidx_format_emails_as_html');
*/

?>