<?php

class DispletRetsIdxQuery{
	private function create_listing_variables($model, $is_single_listing = false){
		if (!empty($model['listings'])) {
			for ($i = 0; $i < count($model['listings']); $i++) {
				if ($model['is_displet_api']) {
					if (!empty($model['options']['address_format'])) {
						$model['listings'][$i]->address = $model['options']['address_format'];
						$model['listings'][$i]->address = str_replace('%%street_number%%', $model['listings'][$i]->street_number, $model['listings'][$i]->address);
						$model['listings'][$i]->address = str_replace('%%street_name%%', $model['listings'][$i]->street_name, $model['listings'][$i]->address);
						$model['listings'][$i]->address = str_replace('%%street_pre_direction%%', $model['listings'][$i]->street_pre_direction, $model['listings'][$i]->address);
						$model['listings'][$i]->address = str_replace('%%street_post_direction%%', $model['listings'][$i]->street_post_dir, $model['listings'][$i]->address);
						$model['listings'][$i]->address = str_replace('%%unit%%', $model['listings'][$i]->unit, $model['listings'][$i]->address);
						if (empty($model['listings'][$i]->unit)) {
							$model['listings'][$i]->address = str_replace('#', '', $model['listings'][$i]->address);
						}
						$model['listings'][$i]->address = trim($model['listings'][$i]->address);
						$model['listings'][$i]->address = str_replace('   ', ' ', $model['listings'][$i]->address);
						$model['listings'][$i]->address = str_replace('  ', ' ', $model['listings'][$i]->address);
					}
					else{
						$model['listings'][$i]->address = $model['listings'][$i]->street_number . ' ' . $model['listings'][$i]->street_pre_direction . ' '  . $model['listings'][$i]->street_name . ' ' . $model['listings'][$i]->street_post_dir;
						if (!empty($model['listings'][$i]->unit)) {
							$model['listings'][$i]->address .= ' #' . $model['listings'][$i]->unit;
						}
						$model['listings'][$i]->address = trim($model['listings'][$i]->address);
						$model['listings'][$i]->address = str_replace('  ', ' ', $model['listings'][$i]->address);
					}
					$half_baths = (!empty($model['listings'][$i]->half_baths)) ? '/' . $model['listings'][$i]->half_baths : '';
					$model['listings'][$i]->bathrooms = $model['listings'][$i]->full_baths . $half_baths;
				}
				else{
					$model['listings'][$i]->sysid = $model['listings'][$i]->id;
					$model['listings'][$i]->list_price = $model['listings'][$i]->attributes->price;
					$model['listings'][$i]->address = $model['listings'][$i]->location->address;
					$model['listings'][$i]->city = $model['listings'][$i]->location->name;
					$model['listings'][$i]->state = $model['listings'][$i]->location->state;
					$model['listings'][$i]->zip = $model['listings'][$i]->location->zip;
					$model['listings'][$i]->num_bedrooms = $model['listings'][$i]->attributes->bedrooms;
					$model['listings'][$i]->bathrooms = $model['listings'][$i]->attributes->bathrooms;
					$model['listings'][$i]->square_feet = $model['listings'][$i]->attributes->square_feet;
					$model['listings'][$i]->property_type = $model['listings'][$i]->category->name;
					$model['listings'][$i]->mls_number = $model['listings'][$i]->attributes->mls_id;
					$model['listings'][$i]->internet_remarks = $model['listings'][$i]->body;
					$model['listings'][$i]->image_urls = new stdClass();
					$model['listings'][$i]->image_urls->primary_big = $model['listings'][$i]->images[0]->src;
					// Swap phones, emails and URLs from description
					if (!empty($model['listings'][$i]->internet_remarks)) {
						$phone = '/([0-9]{3})[-. ]?([0-9]{4})/';
						$email = '/([\S]+)@([\S]+)/';
						$website = '/([\S]+)\.com([\S]+)/';
						$new_body = preg_replace($phone, 'XXX-XXXX', $model['listings'][$i]->internet_remarks);
						$new_body = preg_replace($email, 'XXXX@XXXX', $new_body);
						$new_body = preg_replace($website, 'http://.com', $new_body);
						$model['listings'][$i]->internet_remarks = $new_body;
					}
					if ($is_single_listing) {
						$model['listings'][$i]->latitude = $model['listings'][$i]->location->latitude;
						$model['listings'][$i]->longitude = $model['listings'][$i]->location->longitude;
						$model['listings'][$i]->year_built = $model['listings'][$i]->attributes->year;
						$model['listings'][$i]->area_amenities = $model['listings'][$i]->attributes->amenities;
						// Get largest of each photo
						if (is_array($model['listings'][$i]->images)) {
							$images_array = array();
							// Get largest of each image
							for ($j = $i; $j < count($model['listings'][$i]->images); $j++) {
								if ($model['listings'][$i]->images[$j]->num == $last_num || $j == count($model['listings'][$i]->images) - 1) {
									$last_src = $model['listings'][$i]->images[$j]->src;
								}
								if (($model['listings'][$i]->images[$j]->num > $last_num || $j == count($model['listings'][$i]->images) - 1) && !empty($last_src)) {
									$images_array[] = $last_src;
								}
								$last_num = $model['listings'][$i]->images[$j]->num;
							}
							$model['listings'][$i]->image_urls = new stdClass();
							$model['listings'][$i]->image_urls->all_big = $images_array;
							$model['listings'][$i]->image_urls->all_thumb = $images_array;
							$model['listings'][$i]->image_urls->primary_big = $images_array[$i];
							$model['listings'][$i]->image_urls->primary_thumb = $images_array[$i];
						}
					}
				}
				// Create permalink
				$property_details_page_url = get_permalink($model['options']['property_details_page_id']);
				$permalink_state = (!empty($model['listings'][$i]->state)) ? $model['listings'][$i]->state : 'STATE';
				$permalink_city = (!empty($model['listings'][$i]->city)) ? $model['listings'][$i]->city : 'City';
				$permalink_zip = (!empty($model['listings'][$i]->zip)) ? $model['listings'][$i]->zip : '00000';
				$model['listings'][$i]->permalink = rtrim($property_details_page_url, '/') . '/' .
					stripslashes(str_replace(' ', '-', $permalink_state)) . '/' .
					stripslashes(str_replace(' ', '-', $permalink_city)) . '/' .
					stripslashes(str_replace(' ', '-', $permalink_zip)) . '/' .
					$model['listings'][$i]->sysid . '/' .
					stripslashes(str_replace(' ', '-', str_replace('#', '', $model['listings'][$i]->address)));
				if ($is_single_listing) {
					// Create maps from lat/long & address
					if ($model['listings'][0]->latitude && $model['listings'][0]->longitude && $model['listings'][0]->address && $model['listings'][0]->city && $model['listings'][0]->state) {
						//$model['listings'][0]->maps = '<iframe class="displet-map-iframe" width="100%" height="300" frameborder="0" scrolling="no" marginheight="0" marginwidth="0" src="https://maps.google.com/maps?q=' . $model['listings'][0]->address . ',+' . $model['listings'][0]->city . ',+' . $model['listings'][0]->state . '&amp;cbp=13,15.23,,0,0&amp;t=m&amp;z=14&amp;iwloc=A&amp;source=embed&amp;output=svembed"></iframe>';
						//$model['listings'][0]->maps .= '<iframe class="displet-street-view-iframe" width="100%" height="300" frameborder="0" scrolling="no" marginheight="0" marginwidth="0" src="https://maps.google.com/maps?q=' . $model['listings'][0]->address . ',+' . $model['listings'][0]->city . ',+' . $model['listings'][0]->state . '&amp;layer=c&amp;cbp=13,15.23,,0,0&amp;cbll=' . $model['listings'][0]->latitude . ',' . $model['listings'][0]->longitude . '&amp;t=m&amp;z=14&amp;iwloc=A&amp;source=embed&amp;output=svembed"></iframe>';
						$model['listings'][0]->maps = array(
							'map' => '<div id="displet-map-canvas"></div>',
							'street_view' => '<div id="displet-street-view-canvas"></div>'
						);
					}
				}
			}
		}
		return $model;
	}

	public function get_field_values($field, $api_key){
		$query_url = 'http://api.displet.com/residentials/field_options?field=' . $field . '&authentication_token=' . $api_key;
		//echo $query_url;
		$json_array = wp_remote_get($query_url);
		if (is_array($json_array)) {
			//print_r($json_array);
			$json_data = json_decode($json_array['body']);
			return $json_data->field_options;
		}
	}

	public function get_listing($model) {
		if ($model['is_displet_api']) {
			$query_url = 'http://api.displet.com/residentials/search?authentication_token=' . $model['app_key'] . '&sysid=' . $model['property_id'];
			if (!empty($model['return_fields'])) {
				$query_url .= '&return_fields=' . $model['return_fields'];
			}
			$json_array = wp_remote_get($query_url, array('timeout' => 10));
		}
		else{
			$json_array = wp_remote_get('http://api.oodle.com/api/v2/listings?key=579B95506556&format=json&jsoncallback=none&region=usa&q=' . $model['property_id']);
		}
		if (is_array($json_array)) {
			$json_data = json_decode($json_array['body']);
			if ($model['is_displet_api']) {
				if (!empty($json_data->results)) {
					$model['listings'] = $json_data->results;
				}
			}
			else {
				if (!empty($json_data->listings)) {
					$model['listings'] = $json_data->listings;
				}
			}
		}
		$model = self::create_listing_variables($model, true);
		return $model;
	}

	public function get_listings($model) {
		if (strpos($model['query_url'], 'property_filter_excluded') !== false) {
			$model['listings'] = false;
			$model['meta'] = false;
			return $model;
		}
		$json_array = wp_remote_get($model['query_url'], array('timeout' => 10));
		if (is_array($json_array)) {
			$json_data = json_decode($json_array['body']);
			if ($model['is_displet_api'] && !empty($json_data->results)) {
				$model['listings'] = $json_data->results;
				$model['meta'] = $json_data->meta;
				// Create first and last based on page
				$model['meta']->first = intval($model['listings_per_page']) * intval($model['meta']->page) - intval($model['listings_per_page']) + 1;
				$model['meta']->last = intval($model['meta']->first) + intval($model['options']['listings_per_page']) - 1;
				if ($model['meta']->last > $model['meta']->count) {
					$model['meta']->last = $model['meta']->count;
				}
			}
			else if (!empty($json_data->listings)) {
				$model['listings'] = $json_data->listings;
				$model['meta'] = $json_data->meta;
				$model['meta']->count = $model['meta']->total;
			}
			$model = self::create_listing_variables($model);
		}
		return $model;
	}
	
	public function get_query_url($model) {
		$displetretsidx_option = DispletRetsIdxSettings::get_option();
		if (!is_numeric($model['listings_per_page'])) {
			$model['listings_per_page'] = 10;
		}
		if (!empty($displetretsidx_option['displet_app_key'])) {
			$query_url = 'http://api.displet.com/residentials/search?authentication_token=' . $displetretsidx_option['displet_app_key'];
			$query_url .= '&page=1&limit=' . $model['listings_per_page'];
			if (!empty($model['return_fields'])) {
				$query_url .=  '&return_fields=' . $model['return_fields'];
			}
			if ($model['sort'] == 'price-descending') {
				$sortby = 'desc';
			}
			else{
				$sortby = 'asc';
			}
			$query_url .= '&price_sorter=' . $sortby;

			// Add to query from model
			$model_key_param_pairs = array(
				//'minlistprice' => 'min_list_price', // Using after initial foreach due to property filter possibility
				//'maxlistprice' => 'max_list_price', // Using after initial foreach due to property filter possibility
				'minbedrooms' => 'min_bedrooms',
				'maxbedrooms' => 'max_bedrooms',
				'minbathrooms' => 'min_bathrooms',
				'maxbathrooms' => 'max_bathrooms',
				'minsquarefeet' => 'min_square_feet',
				'maxsquarefeet' => 'max_square_feet',
				'area' => 'area',
				'area_mls_defined' => 'area_mls_defined',
				//'city' => 'city', // Using after initial foreach due to property filter possibility
				//'property_type' => 'property_type', // Using after initial foreach due to property filter possibility
				'minstories' => 'min_stories',
				'waterfront' => 'waterfront',
				'pool_on_property' => 'pool_on_property', 
				'subdivision' => 'subdivision',
				'keyword' => 'keyword',
				'school' => 'school',
				'school_district' => 'school_district',
				'minacres' => 'min_acres',
				//'zip' => 'zip', // Using after initial foreach due to property filter possibility
				'is_foreclosure' => 'is_foreclosure',
				'yearbuilt' => 'year_built',
				'status' => 'status',
				'short_sale' => 'short_sale',
				'last_modified' => 'last_modified',
				'listing_agent_id' => 'listing_agent_id',
				'listing_office_id' => 'listing_office_id',
				'min_lot_size' => 'min_lot_size',
				'is_gated_community' => 'is_gated_community',
				'min_sold_date' => 'min_sold_date',
				'max_sold_date' => 'max_sold_date',
				'master_on_main' => 'master_on_main',
				'basement' => 'basement',
				'min_square_feet_available' => 'min_square_feet_available',
				'max_square_feet_available' => 'max_square_feet_available',
				'min_price_per_sq_feet' => 'min_price_per_sq_feet',
				'max_price_per_sq_feet' => 'max_price_per_sq_feet',
				'street_name' => 'street_name',
				'street_number' => 'street_number'
			);
			foreach ($model_key_param_pairs as $model_key => $parameter) {
				if (!empty($model[strtolower($model_key)])) {
					$query_url .= '&' . $parameter . '=' . str_replace(' ', '%20', $model[strtolower($model_key)]);
				}	
			}
			// Property type filter
			$property_type_filter = array_filter($displetretsidx_option['property_type_include_filter'], array('DispletRetsIdxSearchResults', 'property_type_array_filter_callback'));
			if (!empty($property_type_filter)) {
				$filter_property_types = $displetretsidx_option['property_type_include_filter'];
				if (!empty($model['property_type'])){
					$model_property_types = explode(',', $model['property_type']);
					foreach ($model_property_types as $model_property_type) {
						foreach ($filter_property_types as $filter_property_type_key => $filter_property_type_value) {
							if ($filter_property_type_value == 'true' && strpos(strtolower($filter_property_type_key), strtolower($model_property_type)) !== false) {
								$query_property_types[] = $model_property_type;
							}
						}
					}
					if (!empty($query_property_types)) {
						$query_url .= '&property_type=';
						foreach ($query_property_types as $property_type) {
							$query_url .= str_replace(' ', '%', trim($property_type)) . ',';
						}
						$query_url = rtrim($query_url, ',');
					}
					else{
						$query_url .= '&property_type=property_filter_excluded';
					}
				}
				else{
					foreach ($filter_property_types as $property_type_key => $property_type_value) {
						if ($property_type_value == 'true') {
							$query_property_types[] .= trim($property_type_key);
						}
					}
					if (!empty($query_property_types)) {
						$query_url .= '&property_type=';
						foreach ($query_property_types as $property_type) {
							$query_url .= str_replace(' ', '%', trim($property_type)) . ',';
						}
						$query_url = rtrim($query_url, ',');
					}
				}
			}
			else if (!empty($model['property_type'])) {
				$query_url .= '&property_type=' . str_replace(' ', '%20', $model['property_type']);
			}
			// Zip code filter
			if (!empty($displetretsidx_option['zip_code_include_filter'])) {
				$filter_zips = explode("\n", $displetretsidx_option['zip_code_include_filter']);
				if (!empty($model['zip'])){
					$model_zips = explode(',', $model['zip']);
					foreach ($model_zips as $model_zip) {
						foreach ($filter_zips as $filter_zip) {
							if (strpos($filter_zip, $model_zip) !== false) {
								$query_zips[] = $model_zip;
							}
						}
					}
					if (!empty($query_zips)) {
						$query_url .= '&zip=';
						foreach ($query_zips as $zip) {
							$query_url .= trim($zip) . ',';
						}
						$query_url = rtrim($query_url, ',');
					}
					else{
						$query_url .= '&zip=property_filter_excluded';
					}
				}
				else{
					$query_url .= '&zip=';
					foreach ($filter_zips as $zip) {
						$query_url .= trim($zip) . ',';
					}
					$query_url = rtrim($query_url, ',');
				}
			}
			else if (!empty($model['zip'])) {
				$query_url .= '&zip=' . $model['zip'];
			}
			// City filter
			if (!empty($displetretsidx_option['city_include_filter'])) {
				$filter_cities = explode("\n", $displetretsidx_option['city_include_filter']);
				if (!empty($model['city'])){
					$model_cities = explode(',', $model['city']);
					foreach ($model_cities as $model_city) {
						foreach ($filter_cities as $filter_city) {
							if (strpos(strtolower($filter_city), strtolower($model_city)) !== false) {
								$query_cities[] = $model_city;
							}
						}
					}
					if (!empty($query_cities)) {
						$query_url .= '&city=';
						foreach ($query_cities as $city) {
							$query_url .= str_replace(' ', '%20', trim($city)) . ',';
						}
						$query_url = rtrim($query_url, ',');
					}
					else{
						$query_url .= '&city=property_filter_excluded';
					}
				}
				else{
					$query_url .= '&city=';
					foreach ($filter_cities as $city) {
						$query_url .= str_replace(' ', '%20', trim($city)) . ',';
					}
					$query_url = rtrim($query_url, ',');
				}
			}
			else if (!empty($model['city'])) {
				$query_url .= '&city=' . str_replace(' ', '%20', $model['city']);
			}
			// Min price filter
			if (!empty($displetretsidx_option['min_price_filter'])) {
				$filter_min_price = $displetretsidx_option['min_price_filter'];
				$query_url .= '&min_list_price=';
				if (!empty($model['minlistprice']) && $model['minlistprice'] >= $filter_min_price){
					$query_url .= $model['minlistprice'];
				}
				else{
					$query_url .= $filter_min_price;
				}
			}
			else if (!empty($model['minlistprice'])) {
				$query_url .= '&min_list_price=' . $model['minlistprice'];
			}
			// Max price filter
			if (!empty($displetretsidx_option['max_price_filter'])) {
				$filter_max_price = $displetretsidx_option['max_price_filter'];
				$query_url .= '&max_list_price=';
				if (!empty($model['maxlistprice']) && $model['maxlistprice'] <= $filter_max_price){
					$query_url .= $model['maxlistprice'];
				}
				else{
					$query_url .= $filter_max_price;
				}
			}
			else if (!empty($model['maxlistprice'])) {
				$query_url .= '&max_list_price=' . $model['maxlistprice'];
			}
		}
		// Free version API
		else {
			$query_url = 'http://api.oodle.com/api/v2/listings?key=579B95506556&format=json&jsoncallback=none&num_images=1&image_sizes=m&start=1';

			// Default category/region (default options dropped after switching to Displet API and back)
			if (empty($model['region'])) $model['region'] = 'usa';
			if (empty($model['category'])) $model['category'] = 'housing/sale';

			// Listings per page
			if (!is_numeric($model['listings_per_page'])) {
				$model['listings_per_page'] = 10;
			}
			$query_url .= '&num=' . $model['listings_per_page'];

			// Sorting
			if ($model['sort'] == 'price-descending') {
				$sortby = 'price_reverse';
			}
			else if ($model['sort'] == 'newest') {
				$sortby = 'ctime_reverse';
			}
			else if ($model['sort'] == 'oldest') {
				$sortby = 'ctime';
			}
			else{
				$sortby = 'price';
			}
			$query_url .= '&sort=' . $sortby;

			// Translations - make an Oodle URL query parameter in the form of $model[url_parameter] from each existing $model[parameter] so that each $model[parameter] = url_parameter for '&url_parameter='
			if (!empty($model['minlistprice']) && !empty($model['maxlistprice'])) {
				$model['price'] = (intval($model['minlistprice']) * 1000) . '_' . (intval($model['maxlistprice']) * 1000);
			}
			else if (!empty($model['minlistprice'])) {
				$model['price'] = (intval($model['minlistprice']) * 1000) . '+';
			}
			else if (!empty($model['maxlistprice'])) {
				$model['price'] = (intval($model['maxlistprice']) * 1000) . '-';
			}
			if (!empty($model['minbedrooms'])) {
				$model['bedrooms'] = $model['minbedrooms'] . '+';
			}
			if (!empty($model['maxbedrooms'])) {
				$model['bedrooms'] = $model['maxbedrooms'] . '-';
			}
			if (!empty($model['minbathrooms'])) {
				$model['bathrooms'] = $model['minbathrooms'] . '+';
			}
			if (!empty($model['maxbathrooms'])) {
				$model['bathrooms'] = $model['maxbathrooms'] . '-';
			}
			if (!empty($model['minsquarefeet']) && !empty($model['maxsquarefeet'])) {
				$model['square_feet'] = $model['minsquarefeet'] . '_' . $model['maxsquarefeet'];
			}
			else if (!empty($model['minsquarefeet'])) {
				$model['square_feet'] = $model['minsquarefeet'] . '+';
			}
			else if (!empty($model['maxsquarefeet'])) {
				$model['square_feet'] = $model['maxsquarefeet'] . '-';
			}
			if (!empty($model['area'])) {
				// Prefers to have nationwide region instead of default if location is queried, but need to adapt for Canada
				//$model['region'] = 'usa';
				$model['location'] = $model['area'] . '&radius=0';
			}
			if (!empty($model['area_mls_defined'])) {
				// Prefers to have nationwide region instead of default if location is queried, but need to adapt for Canada
				//$model['region'] = 'usa';
				$model['location'] = $model['area_mls_defined'] . '&radius=0';
			}
			if (!empty($model['city'])) {
				// Prefers to have nationwide region instead of default if location is queried, but need to adapt for Canada
				//$model['region'] = 'usa';
				$model['location'] = $model['city'] . '&radius=0';
			}
			if (!empty($model['zip'])) {
				// Prefers to have nationwide region instead of default if location is queried, but need to adapt for Canada
				//$model['region'] = 'usa';
				$model['location'] = $model['zip'] . '&radius=0';
			}
			if (!empty($model['subdivision'])) {
				if (isset($model['q'])) {
					$model['q'] .= ',' . $model['subdivision'];
				}
				else {
					$model['q'] = $model['subdivision'];
				}
			}
			if (!empty($model['keyword'])) {
				if (isset($model['q'])) {
					$model['q'] .= ',' . $model['keyword'];
				}
				else {
					$model['q'] = $model['keyword'];
				}
			}
			if (!empty($model['property_type'])) {
				if (!empty($model['category'])) {
					// Downcase
					$model['property_type'] = strtolower($model['property_type']);
					// Available to housing/sale & housing/rent
					if ($model['property_type'] == 'house') {
						$model['category'] .= '/home';
					}
					else if ($model['property_type'] == 'condo') {
						$model['category'] .= '/condo';
					}
					else if ($model['property_type'] == 'commercial') {
						$model['category'] .= '/commerical';
					}
					else if ($model['property_type'] == 'mobile') {
						$model['category'] .= '/mobile';
					}
					else if ($model['property_type'] == 'vacation') {
						$model['category'] .= '/vacation';
					}
					else if ($model['property_type'] == 'other') {
						$model['category'] .= '/other';
					}
					else if ($model['property_type'] == 'open_house') {
						$model['category'] .= '/open_house';
					}
					else if ($model['property_type'] == 'storage') {
						$model['category'] .= '/storage';
					}
					// Available only to housing/sale
					else if ($model['property_type'] == 'land') {
						$model['category'] = 'housing/sale/land';
					}
					else if ($model['property_type'] == 'multi') {
						$model['category'] = 'housing/sale/multi_family';
					}
					else if ($model['property_type'] == 'ranch') {
						$model['category'] = 'housing/sale/farm';
					}
					// Available only to housing/rent
					else if ($model['property_type'] == 'lease') {
						$model['category'] = 'housing/rent';
					}
					else if ($model['property_type'] == 'apartment') {
						$model['category'] = 'housing/rent/apartment';
					}
					else if ($model['property_type'] == 'garage') {
						$model['category'] = 'housing/rent/garage';
					}
					else if ($model['property_type'] == 'roommates') {
						$model['category'] = 'housing/rent/roommates';
					}
					else if ($model['property_type'] == 'short_term') {
						$model['category'] = 'housing/rent/short_term';
					}
				}
			}
			if ($model['pool_on_property'] == 'yes') {
				if (isset($model['amenities'])) {
					$model['amenities'] .= ',amenities_pool';
				}
				else {
					$model['amenities'] = 'pool';
				}
			}
			if ($model['is_gated_community'] == 'yes') {
				if (isset($model['amenities'])) {
					$model['amenities'] .= ',amenities_gated';
				}
				else {
					$model['amenities'] = 'gated';
				}
			}

			// Add each parameter from $parameters to the query URL when $model[parameter] = url_parameter for '&url_parameter='
			$parameters = array('region', 'category', 'location', 'q');
			foreach ($parameters as $parameter) {
				if (isset($model[$parameter])) {
					$query_url .= '&' . $parameter . '=' . str_replace(' ', '%20', $model[$parameter]);
				}	
			}

			// Add each Oodle attribute from $attributes to the query URl in the form of &attributes=all_attributes
			$attributes = array('price', 'bedrooms', 'bathrooms', 'square_feet', 'amenities');
			$first = true;
			foreach ($attributes as $attribute) {
				if (isset($model[$attribute])) {
					if ($first) {
						$query_url .= '&attributes=';
					}
					else {
						$query_url .= ',';
					}
					$query_url .= $attribute . '_' . $model[$attribute];
					$first = false;
				}	
			}
		}

		return $query_url;
	}
}

?>