<?php

class DispletRetsIdxSearchResults{
	public function replace_page_content($content) {
		// Retrieve options from settings page
		$displetretsidx_option = DispletRetsIdxSettings::get_option();
		
		$page_id = $displetretsidx_option['search_results_page_id'];
		global $wp_query;
		$property_id = get_query_var('property_id');
		$property_zip = get_query_var('property_zip');
		$property_city = get_query_var('property_city');
		$property_state = get_query_var('property_state');
		if (is_page($page_id) && empty($property_id) && empty($property_zip) && empty($property_city) && empty($property_state) && in_the_loop()) {
			$model = array(
				'options' => $displetretsidx_option,
				'region' => stripslashes($displetretsidx_option['oodle_region']),
				'category' => stripslashes($displetretsidx_option['oodle_category']),
				'orientation' => stripslashes($displetretsidx_option['listings_orientation']),
				'sort' => stripslashes($displetretsidx_option['listings_sort']),
				'is_displet_api' => (!empty($displetretsidx_option['displet_app_key'])) ? true : false,
				'return_fields' => 'city,full_baths,half_baths,primary_big_image_urls,internet_remarks,latitude,list_price,listing_office_name,longitude,mls_number,num_bedrooms,property_type,square_feet,state,status,street_name,street_number,street_post_dir,street_pre_direction,subdivision,sysid,unit,zip',
				'previous_page_url' => '#prev',
				'next_page_url' => '#next'
			);
	
			// Get query from $model
			$model['query_url'] = DispletRetsIdxQuery::get_query_url($model);
	
			// Get listings server-side to pass to templates for crawlable content
			$listings = DispletRetsIdxQuery::get_listings($model);
			$model = array_merge($model, $listings);
	
			$content = DispletRetsIdxLoad::get_template('displet-search-results-jquery.php', $model);
			$content .= DispletRetsIdxLoad::get_template('displet-search-form.php', $model);
			$content .= DispletRetsIdxLoad::get_template('displet-dynamic.php', $model);
		}
		return $content;
	}

	public function is_search_form_widget_area_used($i){
		if (is_active_sidebar('displetretsidx-search-form-' . $i)) {
			return true;
		}
		return false;
	}

	public function is_advanced_search_form_widget_area_used($i){
		if (is_active_sidebar('displetretsidx-search-form-advanced-' . $i)) {
			return true;
		}
		return false;
	}

	public function add_search_form_widget_area(){
		register_sidebar(array(
			'name' => 'Displet Search Form',
			'id' => 'displetretsidx-search-form-1',
			'description' => 'Column 1 of the search form. Use Displet RETS/IDX Search Field widgets here. Refresh the page after adding a field to allow use of another column.',
			'before_widget' => '<div class="displet-field displet-left">',
			'after_widget' => '</div>',
			'before_title' => '',
			'after_title' => '',
		));
		/*
		function is_search_form_widget_area_used($i){
			if (is_active_sidebar('displetretsidx-search-form-' . $i)) {
				return true;
			}
			return false;
		}
		*/
		if (self::is_search_form_widget_area_used(1)) {
			$i = 1;
			while (self::is_search_form_widget_area_used($i)) {
				$i++;
				register_sidebar(array(
					'name' => 'Displet Search Form',
					'id' => 'displetretsidx-search-form-' . $i,
					'description' => 'Column ' . $i . ' of the search form. Use Displet RETS/IDX Search Field widgets here. Refresh the page after adding a field to allow use of another column. Leave empty to not include this column.',
					'before_widget' => '<div class="displet-field displet-left">',
					'after_widget' => '</div>',
					'before_title' => '',
					'after_title' => '',
				));
			}
		}
		register_sidebar(array(
			'name' => 'Displet Search Form - Adv. Section',
			'id' => 'displetretsidx-search-form-advanced-1',
			'description' => 'Column 1 of the advanced section of the search form. Use Displet RETS/IDX Search Field widgets here. Refresh the page after adding a field to allow use of another column. Leave empty to not include an advanced section.',
			'before_widget' => '<div class="displet-field displet-left">',
			'after_widget' => '</div>',
			'before_title' => '',
			'after_title' => '',
		));
		/*
		function is_advanced_search_form_widget_area_used($i){
			if (is_active_sidebar('displetretsidx-search-form-advanced-' . $i)) {
				return true;
			}
			return false;
		}
		*/
		if (self::is_advanced_search_form_widget_area_used(1)) {
			$i = 1;
			while (self::is_advanced_search_form_widget_area_used($i)) {
				$i++;
				register_sidebar(array(
					'name' => 'Displet Search Form - Adv. Section',
					'id' => 'displetretsidx-search-form-advanced-' . $i,
					'description' => 'Column ' . $i . ' of the advanced section of the search form. Use Displet RETS/IDX Search Field widgets here. Refresh the page after adding a field to allow use of another column. Leave empty to not include this column.',
					'before_widget' => '<div class="displet-field displet-left">',
					'after_widget' => '</div>',
					'before_title' => '',
					'after_title' => '',
				));
			}
		}
	}

	public function is_quick_search_form_column_used($form, $column){
		if (is_active_sidebar('displetretsidx-quick-search-' . $form . '-form-' . $column)) {
			return true;
		}
		return false;
	}

	public function add_quick_search_form_widget_area(){
		register_sidebar(array(
			'name' => 'Displet Quick Search 1 Form',
			'id' => 'displetretsidx-quick-search-1-form-1',
			'description' => 'Column 1 of the Quick Search 1 Form. Use Displet RETS/IDX Search Field widgets here. Refresh the page after adding a field to allow use of another column.',
			'before_widget' => '<div class="displet-field displet-left">',
			'after_widget' => '</div>',
			'before_title' => '',
			'after_title' => '',
		));
		if (self::is_quick_search_form_column_used(1, 1)) {
			$form = 1;
			$column = 1;
			while ($form <= 5 && self::is_quick_search_form_column_used($form, 1)) {
				while (self::is_quick_search_form_column_used($form, $column)) {
					$column++;
					register_sidebar(array(
						'name' => 'Displet Quick Search ' . $form . ' Form',
						'id' => 'displetretsidx-quick-search-' . $form . '-form-' . $column,
						'description' => 'Column ' . $column . ' of the Quick Search ' . $form . ' Form. Use Displet RETS/IDX Search Field widgets here. Refresh the page after adding a field to allow use of another column. Leave empty to not include this column.',
						'before_widget' => '<div class="displet-field displet-left">',
						'after_widget' => '</div>',
						'before_title' => '',
						'after_title' => '',
					));
				}
				$form++;
				$column = 1;
				register_sidebar(array(
					'name' => 'Displet Quick Search ' . $form . ' Form',
					'id' => 'displetretsidx-quick-search-' . $form . '-form-' . $column,
					'description' => 'Column ' . $column . ' of the Quick Search ' . $form . ' Form. Use Displet RETS/IDX Search Field widgets here. Refresh the page after adding a field to allow use of another column. Leave empty to not include this column.',
					'before_widget' => '<div class="displet-field displet-left">',
					'after_widget' => '</div>',
					'before_title' => '',
					'after_title' => '',
				));
			}
		}
	}
	
	public function property_type_array_filter_callback($var){
		if ($var == 'false') {
			return false;
		}
		else{
			return $var;
		}
	}

	public function add_search_field_widget(){
		register_widget('DispletRetsIdxSearchField');
	}

	public function set_field_options(){
		$displetretsidx_option = DispletRetsIdxSettings::get_option();
		if (!empty($displetretsidx_option['displet_app_key']) && (empty($displetretsidx_option['displet_app_key_used_for_getting_field_options']) || $displetretsidx_option['displet_app_key'] != $displetretsidx_option['displet_app_key_used_for_getting_field_options'])) {
			$displetretsidx_option['displet_app_key_used_for_getting_field_options'] = $displetretsidx_option['displet_app_key'];
			$displetretsidx_option['field_option_property_type'] = DispletRetsIdxQuery::get_field_values('property_type', $displetretsidx_option['displet_app_key']);
			$displetretsidx_option['field_option_school_district'] = DispletRetsIdxQuery::get_field_values('school_district', $displetretsidx_option['displet_app_key']);
			$displetretsidx_option['field_option_area_mls_defined'] = DispletRetsIdxQuery::get_field_values('area_mls_defined', $displetretsidx_option['displet_app_key']);
			$displetretsidx_option['field_option_city'] = DispletRetsIdxQuery::get_field_values('city', $displetretsidx_option['displet_app_key']);
			if (!empty($displetretsidx_option['field_option_property_type'])) {
				foreach ($displetretsidx_option['field_option_property_type'] as $property_type) {
					$displetretsidx_option['search_values_property_types'][$property_type] = 'true';
				}
			}
			update_option('displet_rets_idx_options', $displetretsidx_option);
		}
	}
}

class DispletRetsIdxSearchField extends WP_Widget {
	function DispletRetsIdxSearchField() {
		parent::__construct(false, 'Displet Search Field', array(
			'description' => 'Use in a Displet Search Form widget area to insert a new search field',// or Quick Search Form',
		));
	}
	function widget($args, $instance) {
		extract($args);
		$displetretsidx_option = DispletRetsIdxSettings::get_option();

        switch ($instance['field']) {
			case 'acres_min' :
				if (!empty($displetretsidx_option['search_values_min_acres']) && !empty($displetretsidx_option['search_values_max_acres']) && !empty($displetretsidx_option['search_values_acres_increment'])) {
					for ($i=floatval($displetretsidx_option['search_values_min_acres']); $i <= floatval($displetretsidx_option['search_values_max_acres']); $i+=floatval($displetretsidx_option['search_values_acres_increment'])) { 
						$min_acres_markup .= '<option value="' . $i . '">' . number_format($i, 2) . '+ acres</option>';
					}
				}
				$search_field_markup =
					'<select id="displet-min_acres" class="displet-search-field displet-full" name="min_acres">
						<option value="none" selected="selected">' . $instance['title'] . '</option>
						' . $min_acres_markup . '
					</select>';
				break;
			case 'area_mls_defined' :
				if (!empty($displetretsidx_option['displet_app_key']) && !empty($displetretsidx_option['field_option_area_mls_defined'])) {
					$search_field_markup =
						'<select multiple id="displet-area_mls_defined" name="area_mls_defined" class="displet-search-field displet-full" data-placeholder="' . $instance['title'] . '">
							<option value="none" disabled> ' . $instance['title'] . '</option>';
					foreach ($displetretsidx_option['field_option_area_mls_defined'] as $area_mls_defined) {
						$search_field_markup .=
							'<option value="' . $area_mls_defined . '">' . $area_mls_defined . '</option>';
					}
					$search_field_markup .=
						'</select>';
				}
				else{
					$search_field_markup =
						'<input type="text" id="displet-area_mls_defined" name="area_mls_defined" class="displet-search-field displet-full" value="" placeholder="' . $instance['title'] . '">';
				}
				break;
			case 'basement' :
				$search_field_markup =
					'<div id="displet-basement" class="displet-radio">
						<label>' . $instance['title'] . '</label>
						<input type="radio" name="basement" class="displet-search-field" value="Y">
						<span>
							Yes
						</span>
						<input type="radio" name="basement" class="displet-search-field" value="N">
						<span>
							No
						</span>
						<input type="radio" name="basement" class="displet-search-field" value="none">
						<span>
							Any
						</span>
					</div>';
				break;
			case 'beds_baths' :
					for ($i=intval($displetretsidx_option['search_values_beds_min']); $i <= intval($displetretsidx_option['search_values_beds_max']); $i++) { 
						$min_beds_markup .= '<option value="' . $i . '">' . $i . '+ beds</option>';
					}
					for ($i=intval($displetretsidx_option['search_values_baths_min']); $i <= intval($displetretsidx_option['search_values_baths_max']); $i++) { 
						$min_baths_markup .= '<option value="' . $i . '">' . $i . '+ baths</option>';
					}
				$search_field_markup =
					'<div class="displet-or">
						<div class="displet-half displet-left">
							<select id="displet-min_bedrooms" name="min_bedrooms" class="displet-search-field">
								<option value="none" selected="selected">Min Beds</option>
								' . $min_beds_markup . '
							</select>
						</div>
						<div class="displet-half displet-right">
							<select id="displet-min_bathrooms" name="min_bathrooms" class="displet-search-field">
								<option value="none"  selected="selected">Min Baths</option>
								' . $min_baths_markup . '
							</select>
						</div>
						<div class="displet-clear"><!-- --></div>
					</div>';
				break;
			case 'city' :
				if (!empty($displetretsidx_option['displet_app_key']) && !empty($displetretsidx_option['field_option_city'])) {
					$search_field_markup =
						'<select multiple id="displet-city" name="city" class="displet-search-field displet-full" data-placeholder="' . $instance['title'] . '">
							<option value="none" disabled> ' . $instance['title'] . '</option>';
					foreach ($displetretsidx_option['field_option_city'] as $city) {
						$search_field_markup .=
							'<option value="' . $city . '">' . $city . '</option>';
					}
					$search_field_markup .=
						'</select>';
				}
				else{
					$search_field_markup =
						'<input type="text" id="displet-city" name="city" class="displet-search-field displet-full" value="" placeholder="' . $instance['title'] . '">';
				}
				break;
			case 'county' :
				$search_field_markup =
					'<input type="text" id="displet-county" name="county" class="displet-search-field displet-full" value="" placeholder="' . $instance['title'] . '">';
				break;
			case 'foreclosure' :
				$search_field_markup =
					'<div id="displet-is_foreclosure" class="displet-radio">
						<label>' . $instance['title'] . '</label>
						<input type="radio" name="is_foreclosure" class="displet-search-field" value="Y">
						<span>
							Yes
						</span>
						<input type="radio" name="is_foreclosure" class="displet-search-field" value="N">
						<span>
							No
						</span>
						<input type="radio" name="is_foreclosure" class="displet-search-field" value="none">
						<span>
							Any
						</span>
					</div>';
				break;
			case 'keywords' :
				$search_field_markup =
					'<input type="text" id="displet-keyword" name="keyword" class="displet-search-field displet-full" value="" placeholder="' . $instance['title'] . '">';
				break;
			case 'master_on_main' :
				$search_field_markup =
					'<div id="displet-master_on_main" class="displet-radio">
						<label>' . $instance['title'] . '</label>
						<input type="radio" name="master_on_main" class="displet-search-field" value="Y">
						<span>
							Yes
						</span>
						<input type="radio" name="master_on_main" class="displet-search-field" value="N">
						<span>
							No
						</span>
						<input type="radio" name="master_on_main" class="displet-search-field" value="none">
						<span>
							Any
						</span>
					</div>';
				break;
			case 'mls_number' :
				$search_field_markup =
					'<input type="text" id="displet-mls_number" name="mls_number" class="displet-search-field displet-full" value="" placeholder="' . $instance['title'] . '">';
				break;
			case 'new_construction' :
				$search_field_markup =
					'<div id="displet-is_new_construction" class="displet-radio">
						<label>' . $instance['title'] . '</label>
						<input type="radio" name="is_new_construction" class="displet-search-field" value="Y">
						<span>
							Yes
						</span>
						<input type="radio" name="is_new_construction" class="displet-search-field" value="N">
						<span>
							No
						</span>
						<input type="radio" name="is_new_construction" class="displet-search-field" value="none">
						<span>
							Any
						</span>
					</div>';
				break;
			case 'pool' :
				$search_field_markup =
					'<div id="displet-pool_on_property" class="displet-radio">
						<label>' . $instance['title'] . '</label>
						<input type="radio" name="pool_on_property" class="displet-search-field" value="Y">
						<span>
							Yes
						</span>
						<input type="radio" name="pool_on_property" class="displet-search-field" value="N">
						<span>
							No
						</span>
						<input type="radio" name="pool_on_property" class="displet-search-field" value="none">
						<span>
							Any
						</span>
					</div>';
				break;
			case 'price_min' :
				for ($i=intval($displetretsidx_option['search_values_min_price']); $i <= intval($displetretsidx_option['search_values_max_price']); $i+=intval($displetretsidx_option['search_values_price_increment'])) {
					if ((!empty($displetretsidx_option['min_price_filter']) && $i < intval($displetretsidx_option['min_price_filter'])) || (!empty($displetretsidx_option['max_price_filter']) && $i > intval($displetretsidx_option['max_price_filter']))) {
					}
					else{
						$price_markup .= '<option value="' . $i . '">$' . number_format($i) . ',000+</option>';
					}
				}
				$search_field_markup =
					'<select id="displet-min_list_price" name="min_list_price" class="displet-search-field displet-full">
						<option value="none" selected="selected">Min Price</option>
						' . $price_markup . '
					</select>';
				break;
			case 'price_max' :
				for ($i=intval($displetretsidx_option['search_values_min_price']); $i <= intval($displetretsidx_option['search_values_max_price']); $i+=intval($displetretsidx_option['search_values_price_increment'])) {
					if ((!empty($displetretsidx_option['min_price_filter']) && $i < intval($displetretsidx_option['min_price_filter'])) || (!empty($displetretsidx_option['max_price_filter']) && $i > intval($displetretsidx_option['max_price_filter']))) {
					}
					else{
						$price_markup .= '<option value="' . $i . '">$' . number_format($i) . ',000-</option>';
					}
				}
				$search_field_markup =
					'<select id="displet-max_list_price" name="max_list_price" class="displet-search-field displet-full">
						<option value="none" selected="selected">Max Price</option>
						' . $price_markup . '
					</select>';
				break;
			case 'price' :
				for ($i=intval($displetretsidx_option['search_values_min_price']); $i <= intval($displetretsidx_option['search_values_max_price']); $i+=intval($displetretsidx_option['search_values_price_increment'])) {
					if ((!empty($displetretsidx_option['min_price_filter']) && $i < intval($displetretsidx_option['min_price_filter'])) || (!empty($displetretsidx_option['max_price_filter']) && $i > intval($displetretsidx_option['max_price_filter']))) {
					}
					else{
						$price_markup .= '<option value="' . $i . '">$' . number_format($i) . ',000</option>';
					}
				}
				$search_field_markup =
					'<div class="displet-or">
						<div class="displet-half displet-left">
							<select id="displet-min_list_price" name="min_list_price" class="displet-search-field">
								<option value="none" selected="selected">Min Price</option>
								' . $price_markup . '
							</select>
						</div>
						<div class="displet-half displet-right">
							<select id="displet-max_list_price" name="max_list_price" class="displet-search-field">
								<option value="none" selected="selected">Max Price</option>
								' . $price_markup . '
							</select>
						</div>
						<div class="displet-clear"><!-- --></div>
						<span class="displet-to">
							To
						</span>
					</div>';
				break;
			case 'property_type' :
				$property_types = $displetretsidx_option['search_values_property_types'];
				if (!empty($displetretsidx_option['property_type_include_filter'])) {
					$property_type_filter = array_filter($displetretsidx_option['property_type_include_filter'], array('DispletRetsIdxSearchResults', 'property_type_array_filter_callback'));
				}
				foreach ($property_types as $property_type_key => $property_type_value) {
					if ($property_type_value == 'true') {
						if (!empty($property_type_filter) && $displetretsidx_option['property_type_include_filter'][$property_type_key] != 'true') {
						}
						else{
							$property_type_markup .= '<option value="' . trim($property_type_key) . '">' . trim($property_type_key) . '</option>';
						}
					}
				}
				$search_field_markup =
					'<select multiple id="displet-property_type" name="property_type" class="displet-search-field displet-full" data-placeholder="' . $instance['title'] . '">
						<option value="none" disabled> ' . $instance['title'] . '</option>
						' . $property_type_markup . '
					</select>';
				break;
			case 'quick_terms' :
				$search_field_markup =
					'<input type="text" id="displet-quick_terms" name="quick_terms" class="displet-search-field displet-full" value="" placeholder="' . $instance['title'] . '">';
				break;
			case 'school' :
				$search_field_markup =
					'<input type="text" id="displet-school" name="school" class="displet-search-field displet-full" value="" placeholder="' . $instance['title'] . '">';
				break;
			case 'school_district' :
				if (!empty($displetretsidx_option['displet_app_key']) && !empty($displetretsidx_option['field_option_school_district'])) {
					$search_field_markup =
						'<select multiple id="displet-school_district" name="school_district" class="displet-search-field displet-full" data-placeholder="' . $instance['title'] . '">
							<option value="none" disabled> ' . $instance['title'] . '</option>';
					foreach ($displetretsidx_option['field_option_school_district'] as $school_district) {
						$search_field_markup .=
							'<option value="' . $school_district . '">' . $school_district . '</option>';
					}
					$search_field_markup .=
						'</select>';
				}
				else{
					$search_field_markup =
						'<input type="text" id="displet-school_district" name="school_district" class="displet-search-field displet-full" value="" placeholder="' . $instance['title'] . '">';
				}
				break;
			case 'short_sale' :
				$search_field_markup =
					'<div id="displet-short_sale" class="displet-radio">
						<label>' . $instance['title'] . ' Sale</label>
						<input type="radio" name="short_sale" class="displet-search-field" value="Y">
						<span>
							Yes
						</span>
						<input type="radio" name="short_sale" class="displet-search-field" value="N">
						<span>
							No
						</span>
						<input type="radio" name="short_sale" class="displet-search-field" value="none">
						<span>
							Any
						</span>
					</div>';
				break;
			case 'square_feet_min' :
				for ($i=intval($displetretsidx_option['search_values_min_square_feet']); $i <= intval($displetretsidx_option['search_values_max_square_feet']); $i+=intval($displetretsidx_option['search_values_square_feet_increment'])) { 
					$sq_ft_markup .= '<option value="' . $i . '">' . number_format($i) . '+ sq ft</option>';
				}
				$search_field_markup =
					'<select id="displet-min_square_feet" name="min_square_feet" class="displet-search-field displet-full">
						<option value="none" selected="selected">Min Sq Ft</option>
						' . $sq_ft_markup . '
					</select>';
				break;
			case 'square_feet_max' :
				for ($i=intval($displetretsidx_option['search_values_min_square_feet']); $i <= intval($displetretsidx_option['search_values_max_square_feet']); $i+=intval($displetretsidx_option['search_values_square_feet_increment'])) { 
					$sq_ft_markup .= '<option value="' . $i . '">' . number_format($i) . '- sq ft</option>';
				}
				$search_field_markup =
					'<select id="displet-max_square_feet" name="max_square_feet" class="displet-search-field displet-full">
						<option value="none" selected="selected">Max Sq Ft</option>
						' . $sq_ft_markup . '
					</select>';
				break;
			case 'square_feet' :
				for ($i=intval($displetretsidx_option['search_values_min_square_feet']); $i <= intval($displetretsidx_option['search_values_max_square_feet']); $i+=intval($displetretsidx_option['search_values_square_feet_increment'])) { 
					$sq_ft_markup .= '<option value="' . $i . '">' . number_format($i) . ' sq ft</option>';
				}
				$search_field_markup =
					'<div class="displet-or">
						<div class="displet-half displet-left">
							<select id="displet-min_square_feet" name="min_square_feet" class="displet-search-field">
								<option value="none" selected="selected">Min Sq Ft</option>
								' . $sq_ft_markup . '
							</select>
						</div>
						<div class="displet-half displet-right">
							<select id="displet-max_square_feet" name="max_square_feet" class="displet-search-field">
								<option value="none" selected="selected">Max Sq Ft</option>
								' . $sq_ft_markup . '
							</select>
						</div>
						<div class="displet-clear"><!-- --></div>
						<span class="displet-to">
							To
						</span>
					</div>';
				break;
			case 'stories' :
				$search_field_markup =
					'<div id="displet-min_stories" class="displet-radio">
						<label>' . $instance['title'] . '</label>
						<input type="radio" name="min_stories" class="displet-search-field" value="1">
						<span>
							1+
						</span>
						<input type="radio" name="min_stories" class="displet-search-field" value="2">
						<span>
							2+
						</span>
						<input type="radio" name="min_stories" class="displet-search-field" value="none">
						<span>
							Any
						</span>
					</div>';
				break;
			case 'subdivision' :
				$search_field_markup =
					'<input type="text" id="displet-subdivision" name="subdivision" class="displet-search-field displet-full" value="" placeholder="' . $instance['title'] . '">';
				break;
			case 'waterfront' :
				$search_field_markup =
					'<div id="displet-waterfront" class="displet-radio">
						<label>' . $instance['title'] . '</label>
						<input type="radio" name="waterfront" class="displet-search-field" value="Y">
						<span>
							Yes
						</span>
						<input type="radio" name="waterfront" class="displet-search-field" value="N">
						<span>
							No
						</span>
						<input type="radio" name="waterfront" class="displet-search-field" value="none">
						<span>
							Any
						</span>
					</div>';
				break;
			case 'zip' :
				$search_field_markup =
					'<input type="text" id="displet-zip" name="zip" class="displet-search-field displet-full" value="" placeholder="' . $instance['title'] . '">';
				break;
		}

	    $search_field_output = $before_widget . $search_field_markup . $after_widget;
		echo $search_field_output;
	}
	function update($new_instance, $old_instance) {
        return $new_instance;
	}
	function form($instance) {
		$displetretsidx_option = DispletRetsIdxSettings::get_option();
		if ($instance['field'] == 'beds_baths') {
			$instance['title'] = 'Beds/Baths';
		}
		else if ($instance['field'] == 'price') {
			$instance['title'] = 'Price Min/Max';
		}
		else if ($instance['field'] == 'square_feet') {
			$instance['title'] = 'Square Feet Min/Max';
		}
        ?>
        <script>
        	jQuery('document').ready(function($){
        		$('.displet-field select').click(function(){
        			var value = $(this).children('option:selected').val();
        			var label_p = $(this).parent('.displet-field').parent('.widget-content').children('.displet-label');
        			var label = $(label_p).children('input');
        			if (value == 'beds_baths' || value == 'price' || value == 'square_feet') {
        				$(label_p).slideUp();
        			}
        			else{
        				var default_value = '';
        				if (value == 'acres_min') {
        					default_value = 'Min Acres';
        				}
        				else if (value == 'area_mls_defined') {
        					default_value = 'Area';
        				}
        				else if (value == 'basement') {
        					default_value = 'Basement';
        				}
        				else if (value == 'city') {
        					default_value = 'City';
        				}
        				else if (value == 'county') {
        					default_value = 'County';
        				}
        				else if (value == 'foreclosure') {
        					default_value = 'Foreclosure';
        				}
        				else if (value == 'keywords') {
        					default_value = 'Keywords: Ex. Pool, Modern, Foreclosure';
        				}
        				else if (value == 'master_on_main') {
        					default_value = 'Master On Main';
        				}
        				else if (value == 'mls_number') {
        					default_value = 'MLS Number';
        				}
        				else if (value == 'new_construction') {
        					default_value = 'New Construction';
        				}
        				else if (value == 'pool') {
        					default_value = 'Pool';
        				}
        				else if (value == 'price_min') {
        					default_value = 'Min Price';
        				}
        				else if (value == 'price_max') {
        					default_value = 'Max Price';
        				}
        				else if (value == 'property_type') {
        					default_value = 'Property Type';
        				}
        				else if (value == 'quick_terms') {
        					default_value = 'City, Zip, Neighborhood, or Condo';
        				}
        				else if (value == 'school') {
        					default_value = 'School';
        				}
        				else if (value == 'school_district') {
        					default_value = 'School District';
        				}
        				else if (value == 'short_sale') {
        					default_value = 'Short Sale';
        				}
        				else if (value == 'square_feet_min') {
        					default_value = 'Min Sq Ft';
        				}
        				else if (value == 'square_feet_max') {
        					default_value = 'Max Sq Ft';
        				}
        				else if (value == 'stories') {
        					default_value = 'Stories';
        				}
        				else if (value == 'subdivision') {
        					default_value = 'Subdivision';
        				}
        				else if (value == 'waterfront') {
        					default_value = 'Waterfront';
        				}
        				else if (value == 'zip') {
        					default_value = 'Zip Code';
        				}
        				$(label).val(default_value);
        				$(label_p).slideDown();
        			}
        		});
        	});
        </script>
		<p class="displet-label <?php echo $this->get_field_id('title'); ?>"<?php if ($instance['field'] == 'beds_baths' || $instance['field'] == 'price' || $instance['field'] == 'square_feet') echo ' style="display:none;"'; ?>>
			<label for="<?php echo $this->get_field_id('title'); ?>">Label: </label>
			<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo attribute_escape($instance['title']); ?>" />
		</p>
		<p class="displet-field">
			<label for="<?php echo $this->get_field_id('field'); ?>">Field: </label>
			<select class="widefat" id="<?php echo $this->get_field_id('field'); ?>" name="<?php echo $this->get_field_name('field'); ?>">
				<option value="acres_min"<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' disabled'; ?><?php if ($instance['field'] == 'acres_min') echo ' selected'; ?>>Acres - Min<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' - Available w/ Upgrade'; ?></option>
				<option value="area_mls_defined"<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' disabled'; ?><?php if ($instance['field'] == 'area_mls_defined') echo ' selected'; ?>>Area (MLS Defined)<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' - Available w/ Upgrade'; ?></option>
				<option value="basement"<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' disabled'; ?><?php if ($instance['field'] == 'basement') echo ' selected'; ?>>Basement<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' - Available w/ Upgrade'; ?></option>
				<option value="beds_baths"<?php if ($instance['field'] == 'beds_baths') echo ' selected'; ?>>Beds/Baths</option>
				<option value="city"<?php if ($instance['field'] == 'city') echo ' selected'; ?>>City</option>
				<option value="county"<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' disabled'; ?><?php if ($instance['field'] == 'county') echo ' selected'; ?>>County<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' - Available w/ Upgrade'; ?></option>
				<option value="foreclosure"<?php if ($instance['field'] == 'foreclosure') echo ' selected'; ?>>Foreclosure</option>
				<option value="keywords"<?php if ($instance['field'] == 'keywords') echo ' selected'; ?>>Keywords</option>
				<option value="master_on_main"<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' disabled'; ?><?php if ($instance['field'] == 'master_on_main') echo ' selected'; ?>>Master On Main<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' - Available w/ Upgrade'; ?></option>
				<option value="mls_number"<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' disabled'; ?><?php if ($instance['field'] == 'mls_number') echo ' selected'; ?>>MLS Number<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' - Available w/ Upgrade'; ?></option>
				<option value="new_construction"<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' disabled'; ?><?php if ($instance['field'] == 'new_construction') echo ' selected'; ?>>New Construction<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' - Available w/ Upgrade'; ?></option>
				<option value="pool"<?php if ($instance['field'] == 'pool') echo ' selected'; ?>>Pool</option>
				<option value="price_min"<?php if ($instance['field'] == 'price_min') echo ' selected'; ?>>Price - Min</option>
				<option value="price_max"<?php if ($instance['field'] == 'price_max') echo ' selected'; ?>>Price - Max</option>
				<option value="price"<?php if ($instance['field'] == 'price') echo ' selected'; ?>>Price - Min/Max</option>
				<option value="property_type"<?php if ($instance['field'] == 'property_type') echo ' selected'; ?>>Property Type</option>
				<option value="quick_terms"<?php if ($instance['field'] == 'quick_terms') echo ' selected'; ?>>Quick Terms</option>
				<option value="school"<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' disabled'; ?><?php if ($instance['field'] == 'school') echo ' selected'; ?>>School<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' - Available w/ Upgrade'; ?></option>
				<option value="school_district"<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' disabled'; ?><?php if ($instance['field'] == 'school_district') echo ' selected'; ?>>School District<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' - Available w/ Upgrade'; ?></option>
				<option value="short_sale"<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' disabled'; ?><?php if ($instance['field'] == 'short_sale') echo ' selected'; ?>>Short Sale<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' - Available w/ Upgrade'; ?></option>
				<option value="square_feet_min"<?php if ($instance['field'] == 'square_feet_min') echo ' selected'; ?>>Square Feet - Min</option>
				<option value="square_feet_max"<?php if ($instance['field'] == 'square_feet_max') echo ' selected'; ?>>Square Feet - Max</option>
				<option value="square_feet"<?php if ($instance['field'] == 'square_feet') echo ' selected'; ?>>Square Feet - Min/Max</option>
				<option value="stories"<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' disabled'; ?><?php if ($instance['field'] == 'stories') echo ' selected'; ?>>Stories<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' - Available w/ Upgrade'; ?></option>
				<option value="subdivision"<?php if ($instance['field'] == 'subdivision') echo ' selected'; ?>>Subdivision</option>
				<option value="waterfront"<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' disabled'; ?><?php if ($instance['field'] == 'waterfront') echo ' selected'; ?>>Waterfront<?php if (empty($displetretsidx_option['displet_app_key'])) echo ' - Available w/ Upgrade'; ?></option>
				<option value="zip"<?php if ($instance['field'] == 'zip') echo ' selected'; ?>>Zip Code</option>
			</select>
		</p>
        <?php
	}
}

add_filter('the_content', array('DispletRetsIdxSearchResults', 'replace_page_content'));
add_action('init', array('DispletRetsIdxSearchResults', 'add_search_form_widget_area'));
add_action('init', array('DispletRetsIdxSearchResults', 'add_quick_search_form_widget_area'));
add_action('widgets_init', array('DispletRetsIdxSearchResults', 'add_search_field_widget'));

?>