<?php
	/***************************
	Available Variables:
	$model['options'] = array(); // All fields from settings/settings-page.php
	$model = array(
		'is_displet_api',
		'query_url'
	);
	$model['meta'] = array(
		'first',
		'last',
		'count',
		'limit',
		'page',
		'list_price_min',
		'list_price_max',
		'list_price_mean',
		'square_feet_min',
		'square_feet_max',
		'square_feet_mean'
	);
	$model['listings'][$i] = array(
		'address',
		'bathrooms',
		'city',
		'full_baths',
		'half_baths',
		'image_urls',
		'internet_remarks',
		'latitude',
		'listing_office_name',
		'longitude',
		'mls_number',
		'num_bedrooms',
		'permalink',
		'property_type',
		'square_feet',
		'street_name',
		'street_number',
		'street_post_dir',
		'state',
		'subdivision',
		'sysid',
		'zip'
	);
	***************************/
	// Echo query URL
	echo '<!-- Displet Query: ' . $model['query_url'] . ' -->';
?>
<div id="displet-sidescroller-widget" class="displet-listings-carousel">
	<?php if (isset($model['listings']) && count($model['listings'] > 0)) : ?>
		<ul>
		<?php
			$i = 1;
			foreach ($model['listings'] as $listing) :
				// Create address & bathrooms
				if ($model['is_displet_api']) {
					$listing->address = trim($listing->street_number . ' ' . $listing->street_name . ' ' . $listing->street_post_dir);
					$half_baths = (!empty($listing->half_baths)) ? '/' . $listing->half_baths : '';
					$listing->bathrooms = $listing->full_baths . $half_baths;
				}
				// Translate variables for free version
				else{
					$listing->sysid = $listing->id;
					$listing->list_price = $listing->attributes->price;
					$listing->address = $listing->location->address;
					$listing->city = $listing->location->name;
					$listing->state = $listing->location->state;
					$listing->zip = $listing->location->zip;
					$listing->num_bedrooms = $listing->attributes->bedrooms;
					$listing->bathrooms = $listing->attributes->bathrooms;
					$listing->square_feet = $listing->attributes->square_feet;
					$listing->property_type = $listing->category->name;
					$listing->mls_number = $listing->attributes->mls_id;
					$listing->internet_remarks = $listing->body;
				}
				// Create permalink
				$listing->base_url = get_permalink($model['options']['property_details_page_id']);
				$permalink_state = (!empty($listing->state)) ? $listing->state : 'STATE';
				$permalink_city = (!empty($listing->city)) ? $listing->city : 'City';
				$permalink_zip = (!empty($listing->zip)) ? $listing->zip : '00000';
				$listing->permalink = rtrim($listing->base_url, '/') . '/' .
					stripslashes(str_replace(' ', '-', $permalink_state)) . '/' .
					stripslashes(str_replace(' ', '-', $permalink_city)) . '/' .
					stripslashes(str_replace(' ', '-', $permalink_zip)) . '/' .
					$listing->sysid . '/' .
					stripslashes(str_replace(' ', '-', str_replace('#', '', $listing->address)));
				// Swap phones, emails and URLs from description
				if (!empty($listing->internet_remarks)) {
					$phone = '/([0-9]{3})[-. ]?([0-9]{4})/';
					$email = '/([\S]+)@([\S]+)/';
					$website = '/([\S]+)\.com([\S]+)/';
					$new_body = preg_replace($phone, 'XXX-XXXX', $listing->internet_remarks);
					$new_body = preg_replace($email, 'XXXX@XXXX', $new_body);
					$new_body = preg_replace($website, 'http://.com', $new_body);
					$listing->internet_remarks = $new_body;
				}
		?>
			<li><a class="displet-sidescroller-widget-listing displet-listing-<?php echo $i; ?>" href="<?php echo $listing->permalink; ?>">
				<div class="displet-sidescroller-widget-thumb-container">
					<img class="displet-image-value"<?php if ($listing->images[0]->src) echo ' src=' . $listing->images[0]->src; ?> />
				</div>
				<div class="displet-sidescroller-widget-price-container">
					<span class="displet-dollar">$</span>
					<span class="displet-sidescroller-widget-listing-price displet-price-value">
						<?php echo number_format($listing->list_price); ?>
					</span>
					<div class="displet-clear"><!-- --></div>
				</div>
				<div class="displet-sidescroller-widget-info">
					<div class="displet-sidescroller-widget-address">
						<div class="displet-street-address displet-address-value">
							<?php echo $listing->address; ?>
						</div>
						<div class="displet-city-state-zip">
							<span class="displet-city-value"><?php echo $listing->city; ?></span>,
							<span class="displet-state-value"><?php echo $listing->state; ?></span>
							<span class="displet-zip-value"><?php echo $listing->zip; ?></span>
						</div>
					</div>
					<div class="displet-sidescroller-widget-specs">
							<div class="displet-beds-baths">
								<span class="displet-beds displet-beds-value">
									<?php echo $listing->num_bedrooms; ?>
								</span>
								Bed /
								<span class="displet-full-baths displet-baths-value">
									<?php echo $listing->bathrooms; ?>
								</span>
								Bath
							</div>
							<div class="displet-square-feet">
								<span class="displet-square-feet-value"><?php echo number_format($listing->square_feet); ?></span>
								Sq. Ft.
							</div>
							<div class="displet-property-type">
								Property Type:
								<span class="displet-property-type-value"><?php $property_type = str_replace('Houses', 'House', $listing->property_type); echo str_replace('Condos, Townhouses & Apts for Sale', 'Condo / Townhouse / Apt', $property_type); ?></span>
							</div>
					</div>
				</div>
				<div class="displet-view-details">
					View Details
				</div>
			</a></li>
		<?php $i++; endforeach; ?>
		</ul>
		<div class="displet-navigation">
			<div class="displet-navigation-inner">	
				<a class="displet-navigation-previous">
					Previous
				</a>
				<a class="displet-navigation-next">
					Next
				</a>
			</div>
		</div>
	<?php else : ?>
		<div class="displet-sidescroller-widget-no-results"><span>No listings available</span></div>
	<?php endif ?>
</div>